/***********************************************************

	PICSYS18 USB BOOTLOADER
	io_cfg.h

	Version 0.6: 2009/09/25

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#ifndef IO_CFG_H
#define IO_CFG_H

/** I N C L U D E S *************************************************/
#include "usbcfg.h"

/** T R I S *********************************************************/
#define INPUT_PIN           1
#define OUTPUT_PIN          0

/*------------------------------------------------------------------*/

#if defined(PICSYS18_SP)
/** U S B ***********************************************************/

#define usb_bus_sense       1
#define self_power          0

/** L E D ***********************************************************/
#define mInitAllLEDs()      LATCbits.LATC1=1; TRISCbits.TRISC1=0; LATDbits.LATD7 = 1; TRISDbits.TRISD7=0;

#define mLED_1              LATCbits.LATC1
#define mLED_2              LATDbits.LATD7

#define mLED_1_On()         mLED_1 = 0;
#define mLED_2_On()         mLED_2 = 0;

#define mLED_1_Off()        mLED_1 = 1;
#define mLED_2_Off()        mLED_2 = 1;

#define mLED_1_Toggle()     mLED_1 = !mLED_1;
#define mLED_2_Toggle()     mLED_2 = !mLED_2;

/** S W I T C H *****************************************************/
#define mInitAllSwitches()  TRISBbits.TRISB1=1;
#define mInitSwitch2()      TRISBbits.TRISB1=1;
#define sw2                 PORTBbits.RB1

/*------------------------------------------------------------------*/

#elif defined(PICSYS18_XBEE)
/** U S B ***********************************************************/

#define usb_bus_sense       1
#define self_power          0

///** L E D ***********************************************************/
#define mInitAllLEDs()      LATB &= 0x7F; TRISB &= 0x7F;LATC &= 0xFB; TRISC &= 0xFB;

#define mLED_1              LATCbits.LATC2
#define mLED_2              LATBbits.LATB7

#define mLED_1_On()         mLED_1 = 1;
#define mLED_2_On()         mLED_2 = 1;

#define mLED_1_Off()        mLED_1 = 0;
#define mLED_2_Off()        mLED_2 = 0;

#define mLED_1_Toggle()     mLED_1 = !mLED_1;
#define mLED_2_Toggle()     mLED_2 = !mLED_2;
//
///** S W I T C H *****************************************************/
#define mInitAllSwitches()  TRISBbits.TRISB5=1;
#define mInitSwitch2()      TRISBbits.TRISB5=1;

#define sw2                 PORTBbits.RB5

/*------------------------------------------------------------------*/

#elif defined(PIC18F_MOD_2553)
/** U S B ***********************************************************/

#define usb_bus_sense       1
#define self_power          1

/** L E D ***********************************************************/
#define mInitAllLEDs()      TRISAbits.TRISA5=0;LATAbits.LATA5=1;

#define mLED_1              LATAbits.LATA5
#define mLED_1_On()         mLED_1 = 0;
#define mLED_1_Off()        mLED_1 = 1;
#define mLED_1_Toggle()     mLED_1 = !mLED_1;

/** S W I T C H *****************************************************/
#define mInitAllSwitches()  INTCON2bits.RBPU = 0;TRISBbits.TRISB6=1;TRISBbits.TRISB7=1;
#define mInitSwitch2()      TRISBbits.TRISB6=1;
#define mInitSwitch3()      TRISBbits.TRISB7=1;
#define sw2                 PORTBbits.RB6
#define sw3                 PORTBbits.RB7

/*------------------------------------------------------------------*/

#elif defined(PIC18_DEV_2550URL)
/** U S B ***********************************************************/

#define usb_bus_sense       1
#define self_power          1

/** L E D ***********************************************************/
#define mInitAllLEDs()      LATA |= 0x30; TRISA &= 0xCF;

#define mLED_1              LATAbits.LATA4
#define mLED_2              LATAbits.LATA5

#define mLED_1_On()         mLED_1 = 0;
#define mLED_2_On()         mLED_2 = 0;

#define mLED_1_Off()        mLED_1 = 1;
#define mLED_2_Off()        mLED_2 = 1;

#define mLED_1_Toggle()     mLED_1 = !mLED_1;
#define mLED_2_Toggle()     mLED_2 = !mLED_2;
//

/** S W I T C H *****************************************************/
#define mInitAllSwitches()  LATCbits.LATC1=0;TRISCbits.TRISC1=0;INTCON2bits.RBPU=0;TRISB|=0xfc;
#define mInitSwitch2()      TRISBbits.TRISB2=1;
#define sw2                 PORTBbits.RB2

/*------------------------------------------------------------------*/

#else
    #error Not a supported board (yet), add I/O pin mapping in __FILE__, line __LINE__
#endif

#endif //IO_CFG_H
