/***********************************************************

	pic18clcd.c

	Version 0.92: 2009/10/08

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys18.h"

#if defined(USE_CLCD)

static byte rsPin, ePin ;
static byte dbPin[4] ;


/*----------------------------------------------------------
	__CLCD_outN():ʃjuLCDW[ɏo
----------------------------------------------------------*/

static void
__CLCD_outN(byte c)
{
#if defined(OPTIMIZE)
	OPT_SEG1 = (c >> 4) & 1 ;
	OPT_SEG2 = (c >> 5) & 1 ;
	OPT_SEG3 = (c >> 6) & 1 ;
	OPT_SEG3 = (c >> 7) & 1 ;

#if defined(OPT_CLCD_CLK)
	OPT_CLCD_CLK = 1 ;
	delayMicroseconds(1) ;
	OPT_CLCD_CLK = 0 ;
#else
	OPT_SR_CLK = 1 ;
	delayMicroseconds(1) ;
	OPT_SR_CLK = 0 ;
#endif
#else
	char i ;
	
	for (i = 0; i < 4; i++)
		bitOut(dbPin[i], c & BIT(i + 4)) ;

	bitOut(ePin, HIGH) ;
	bitOut(ePin, LOW) ;
#endif
}


/*----------------------------------------------------------
	__CLCD_outB():oCgf[^LCDW[ɏo
----------------------------------------------------------*/

static void
__CLCD_outB(byte c)
{
#if defined(OPTIMIZE)
	OPT_SEG1 = (c >> 4) & 1 ;
	OPT_SEG2 = (c >> 5) & 1 ;
	OPT_SEG3 = (c >> 6) & 1 ;
	OPT_SEG4 = (c >> 7) & 1 ;

#if defined(OPT_CLCD_CLK)
	OPT_CLCD_CLK = 1 ;
	delayMicroseconds(1) ;
	OPT_CLCD_CLK = 0 ;
#else
	OPT_SR_CLK = 1 ;
	delayMicroseconds(1) ;
	OPT_SR_CLK = 0 ;
#endif

	OPT_SEG1 = (c >> 0) & 1 ;
	OPT_SEG2 = (c >> 1) & 1 ;
	OPT_SEG3 = (c >> 2) & 1 ;
	OPT_SEG4 = (c >> 3) & 1 ;

#if defined(OPT_CLCD_CLK)
	OPT_CLCD_CLK = 1 ;
	delayMicroseconds(1) ;
	OPT_CLCD_CLK = 0 ;
#else
	OPT_SR_CLK = 1 ;
	delayMicroseconds(1) ;
	OPT_SR_CLK = 0 ;
#endif
	
#else
	char i ;

	for (i = 0; i < 4; i++)
		bitOut(dbPin[i], c & BIT(i + 4)) ;
	bitOut(ePin, HIGH) ;
	bitOut(ePin, LOW) ;

	for (i = 0; i < 4; i++)
		bitOut(dbPin[i], c & BIT(i)) ;
	bitOut(ePin, HIGH) ;
	bitOut(ePin, LOW) ;
#endif
}


/***********************************************************
	t̏֐
***********************************************************/

void
CLCD_init(byte rs, byte e, byte seg1, byte seg2, byte seg3, byte seg4)
{
	char i ;

#if defined(PICSYS18_SP)
	/* ł͗pȂR/WOhɗƂ */
	pinMode(CLCD_RW, OUTPUT) ;
	digitalWrite(CLCD_RW, LOW) ;
	
	/* 7SEGȂǂLED𖳌 */
	pinMode(SR_DAT, OUTPUT) ;
	pinMode(SR_CLK, OUTPUT) ;
	shiftOut(SR_DAT, SR_CLK, LSBFIRST, 0xff) ;
#endif

	rsPin = rs ;
	ePin = e ;
	dbPin[0] = seg1 ;
	dbPin[1] = seg2 ;
	dbPin[2] = seg3 ;
	dbPin[3] = seg4 ;

	pinMode(rsPin, OUTPUT) ;
	pinMode(ePin, OUTPUT) ;

	digitalWrite(ePin, LOW) ;

// f[^̏o̓so̓[hɕύX
	for (i = 0; i < 4; i++)
		pinMode(dbPin[i], OUTPUT) ;

	delayMilliseconds(20) ;	// LCD̃p[IZbg̑҂: 15msȏ
        
// 4rbgC^[tF[Xɐݒ肷邽߂̏vgR
	digitalWrite(rsPin, LOW) ;	// R}hWX^̑I

	__CLCD_outN(CLCD_INTERFACE_8BIT) ;
	delayMilliseconds(5) ; // 4.1msȏ
	__CLCD_outN(CLCD_INTERFACE_8BIT) ;
	delayMilliseconds(1) ;
	__CLCD_outN(CLCD_INTERFACE_8BIT) ;
	delayMilliseconds(1) ;

// C^[tF[X4rbg
	__CLCD_outN(CLCD_INTERFACE_4BIT) ;
	delayMilliseconds(1) ;

// sƃtHg̐ݒ
	CLCD_cmd(CLCD_2LINE) ;

// fBXvC̕\
	CLCD_cmd(CLCD_DISPLAY_OFF) ;
	CLCD_cmd(CLCD_DISPLAY_ON & CLCD_CURSOR_ON & CLCD_BLINK_ON) ;

// Gg[[h̐ݒ
	CLCD_cmd(CLCD_CURSOR_INC) ;
// ȏŏvgRI

	CLCD_cmd(CLCD_CLEAR) ;
}

void
CLCD_initDefault()
{
#if defined(PICSYS18_SP)
	CLCD_init(CLCD_RS, CLCD_E, SEG1, SEG2, SEG3, SEG4) ;
#else
	CLCD_init(SR_DAT, SR_CLK, SEG1, SEG2, SEG3, SEG4) ;
#endif
}


/***********************************************************
	tւ̃R}h
***********************************************************/

void
CLCD_cmd(byte cmd)
{
	bitOut(rsPin, LOW) ;	// R}hWX^̑I

	__CLCD_outB(cmd) ;

	if (cmd < 0x04)	
		delayMilliseconds(2) ;	// ̃R}h͏Ԃ
	else
		delayMicroseconds(50) ;
}


/***********************************************************
	f[^̎w蕶tւ̕o
***********************************************************/

void
CLCD_data(byte data)
{
	bitOut(rsPin, HIGH) ;	// f[^WX^̑I

	__CLCD_outB(data) ;

	delayMicroseconds(50) ;
}


/***********************************************************
	t̃J[\
***********************************************************/

void
CLCD_setCursor(unsigned char row, unsigned char line)
{
	line *= 0x40 ;
	row += line ;
		
	CLCD_cmd(CLCD_DDRAM_ADDR | row) ;
}


/***********************************************************
	tւ(RAM)o
***********************************************************/

void
CLCD_puts(char *s)
{
	while(*s)
		CLCD_putc(*s++) ;
}


/***********************************************************
	tւ(ROM)o
***********************************************************/

void
CLCD_putrs(const rom char *s)
{
	while(*s)
		CLCD_putc(*s++) ;
}

#endif
