/***********************************************************

	pic18dml.c
	
	Version 0.92: 2009/09/21

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys18.h"

#if defined(USE_DML)

#if defined(PIC_DEV_2550URL)
byte dataPin ; // hbg}gbNXLEDp̃VtgWX^̃f[^s
byte clockPin ; // hbg}gbNXLEDp̃VtgWX^̃NbNs
byte ePin ; // Jo͂̃Cl[us
byte dbPin[3] ; // Jo͂̑Is
#else
static byte dataPin ; // hbg}gbNXLEDp̃VtgWX^̃f[^s
static byte clockPin ; // hbg}gbNXLEDp̃VtgWX^̃NbNs
static byte ePin ; // Jo͂̃Cl[us
static byte dbPin[3] ; // Jo͂̑Is
#endif

static byte gDL = 0 ; //hbg}gbNXLED̃_Ci~bN_̑Ώۍs
/* hbg}gbNXLED̕\f[^i[̈FVRAM̂悤Ȃ*/
static byte gMXR[8] ; /*  */
static byte gMXG[8] ; /*  */


/***********************************************************
	hbg}gbNXLED̏
***********************************************************/

void
DML_init(byte rs, byte e, byte db4, byte db5, byte db6, byte db7)
{
	/* I/Os̊tpɋL^ */
	dataPin = rs ;
	clockPin = e ;
	dbPin[0] = db4 ;
	dbPin[1] = db5 ;
	dbPin[2] = db6 ;
	ePin = db7 ;
  
	pinMode(dataPin, OUTPUT) ; // VtgWX^ւ̃f[^so͂
	pinMode(clockPin, OUTPUT) ; // VtgWX^ւ̃NbNso͂
  
	/* ȒIsƃCl[uso͂ */
	pinMode(dbPin[0], OUTPUT) ;
	pinMode(dbPin[1], OUTPUT) ;
	pinMode(dbPin[2], OUTPUT) ;
	pinMode(ePin, OUTPUT) ;

	bitOut(ePin, LOW) ; // JANeBu
  
	DML_clear() ; // ɕ\NA
}


/***********************************************************
	hbg}gbNXLEDւ̏o
***********************************************************/

/* hbg}gbNXLED̕\NA */
void
DML_clear()
{
	int i ;

	for (i = 0 ; i < 8 ; i++) {
		gMXR[i] = 0 ;
		gMXG[i] = 0 ;
	}
}


/* hbg}gbNXLEDւ̃vbg */
/* 0:A1:ԁA2:΁A3: */
void
DML_plot(int x, int y, byte color)
{
	byte w ;

	w = (1 << x) ;

	/* hbgf[^̏ */
	switch (0b11 & color) {
		case DML_DOT_BLACK:
			gMXR[y] &= ~w ;
			gMXG[y] &= ~w ;
			break ;
		case DML_DOT_RED:
			gMXR[y] |= w ;
			gMXG[y] &= ~w ;
			break ;
		case DML_DOT_GREEN:
			gMXR[y] &= ~w ;
			gMXG[y] |= w ;
			break ;
		case DML_DOT_ORANGE:
			gMXR[y] |= w ;
			gMXG[y] |= w ;
			break ;
	}
}


/***********************************************************
	_Ci~bN\F荞݃T[rX[`̌Ăяo
***********************************************************/

#ifdef OPTIMIZE
void
isr_DML_update()
{
	/* \錅̊mFFӂĂOɏ񂳂 */
	if (gDL >= 8)
		gDL = 0 ;

	OPT_SEG4 = 0 ; // f[^XVɔRANeBu  

#if defined(PIC_DEV_2550URL)
	isr_optShiftOut(MSBFIRST, 0x00) ;
	isr_optShiftOut(MSBFIRST, 0x00) ;

	isr_SW_update() ;
#endif

	isr_optShiftOut(MSBFIRST, gMXR[gDL]) ; // ԐFo
	isr_optShiftOut(MSBFIRST, gMXG[gDL]) ; // ΐFo

  /* R̕\s̑I */
  	OPT_SEG1 = (gDL & 0b001) ? 1: 0 ;
  	OPT_SEG2 = (gDL & 0b010) ? 1: 0 ;
  	OPT_SEG3 = (gDL & 0b100) ? 1: 0 ;
  
  	OPT_SEG4 = 1 ;

	gDL++ ;
}

#else

void
isr_DML_update()
{
	/* \錅̊mFFӂĂOɏ񂳂 */
	if (gDL >= 8)
		gDL = 0 ;

	isr_bitOut(ePin, LOW) ; // f[^XVɔRANeBu

#if defined(PIC_DEV_2550URL)
	shiftOut(dataPin, clockPin, MSBFIRST, 0x00) ;
	shiftOut(dataPin, clockPin, MSBFIRST, 0x00) ;

	isr_SW_update() ;
#endif

	shiftOut(dataPin, clockPin, MSBFIRST, gMXR[gDL]) ; // ԐFo
	shiftOut(dataPin, clockPin, MSBFIRST, gMXG[gDL]) ; // ΐFo

	/* R̕\s̑I */
	isr_bitOut(dbPin[0], (gDL & 0b001) ? 1: 0) ;
	isr_bitOut(dbPin[1], (gDL & 0b010) ? 1: 0) ;
	isr_bitOut(dbPin[2], (gDL & 0b100) ? 1: 0) ;

	isr_bitOut(ePin, HIGH) ; // RANeBu\ĊJ

	gDL++ ;
}

#endif

#endif
