/***********************************************************

	pic18seg7.c

	Version 0.92: 2009/10/08

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys18.h"

#ifdef USE_SEG7

#if defined(PIC_DEV_2550URL)
byte dataPin, clockPin ;
byte segDigit[NDIGIT] ;
#else
static byte dataPin, clockPin ;

static byte segDigit[NDIGIT_LED] ;
#endif


/* 7ZOgLED̃_Ci~bN_̑Ώی */
static unsigned char gDL = 0 ;
/* 7ZOgLED̕\f[^i[̈ */
static byte g7SEG[NDIGIT_LED] ;

/* 7ZOgLED̕\p^[ */
static rom byte gPTN[] = {
	0b11111100, /* 0 */
	0b01100000,
	0b11011010,
	0b11110010,
	0b01100110,
	0b10110110,
	0b10111110,
	0b11100000,
	0b11111110,
	0b11100110, /* 9 */

	0b11101110, /* A */
	0b00111110, /* b */
	0b00011010, /* c */
	0b01111010, /* d */
	0b10011110, /* E */
	0b10001110, /* F */
	0b00000000, /*   */
	0b00000010, /* - */
	0b01101110, /* H */
	0b00011100, /* L */
	0b11000110, /* ~ */
	0b00111010, /* _ */
} ;


/***********************************************************
	VZOgLED̏
***********************************************************/

void
SEG7_init(byte dat, byte clk, byte seg1, byte seg2, byte seg3, byte seg4)
{
	char i ;
	
	dataPin = dat ;
	clockPin = clk ;
	segDigit[0] = seg1 ;
	segDigit[1] = seg2 ;
	segDigit[2] = seg3 ;
	segDigit[3] = seg4 ;
#if defined(PICSYS18_SP)
	segDigit[4] = SEG5 ;
#endif
	pinMode(clockPin, OUTPUT) ;
	pinMode(dataPin, OUTPUT) ;

	shiftOut(dataPin, clockPin, LSBFIRST, 0xff) ;

	for (i = 0; i < NDIGIT_LED; i++) {
	   pinMode(segDigit[i], OUTPUT) ;
	   bitOut(segDigit[i], HIGH) ;
	   g7SEG[i] = 0 ;
    }
}


#if defined(PICSYS18_SP)

void
SEG7_initDefault()
{
	SEG7_init(SR_DAT, SR_CLK, SEG1, SEG2, SEG3, SEG4) ;
}

#endif


/***********************************************************
	VZOgLEDւ̏o
***********************************************************/

/* 7ZOgLEDւ1o */
void
SEG7_setDigit(char i, char n)
{
	if (n >= sizeof(gPTN)/sizeof(byte)) {
		/* Ȓl̏ꍇɂ́A */
		g7SEG[(i & 3)] = 0b00000000 ;
	} else {
		/* lɑΉ_p^[̐ݒ */
		g7SEG[(i & 3)] = gPTN[n] ;

		/* 傫ꍇɂ́Ahbgǉ\ */
		if (i >= NDIGIT)
			g7SEG[(i & 3)] |= 0b10000000 ;
	}
}


/* lS̃f[^Ƃĕ\ */
void
SEG7_write(int n, byte type)
{
	byte sign = FALSE ;
	byte head = SEG7_BLANK ;
	
	if (n < 0) {
		sign = TRUE ;
		head = SEG7_MINUS ;
		n = -n ;
	}
	
	if (type == SEG7_HEX) {
		SEG7_setDigit(3, n & 0xf) ;
	} else {	
		SEG7_setDigit(3, n % 10) ;
	}

	if (type == SEG7_INT) {
		/* [TvXŕKvłΐ擪Ƀ}CiX\ */
		if (n >= 10) {
			SEG7_setDigit(2, (n / 10) % 10) ;
			if (n >= 100) {
				SEG7_setDigit(1, (n / 100) % 10) ;
				if (n >= 1000) {
					SEG7_setDigit(0, (n / 1000) % 10) ;
				} else {
					SEG7_setDigit(0, head) ;
				}
			} else {
				SEG7_setDigit(1, head) ;
				SEG7_setDigit(0, SEG7_BLANK) ;
			}
		} else {
			SEG7_setDigit(2, head) ;
			SEG7_setDigit(1, SEG7_BLANK) ;
			SEG7_setDigit(0, SEG7_BLANK) ;
		}
	} else if (type == SEG7_HEX) {
		SEG7_setDigit(2, (n >> 4) & 0xf) ;
		SEG7_setDigit(1, (n >> 8) & 0xf) ;
		SEG7_setDigit(0, (n >> 12) & 0xf);
	} else {
		SEG7_setDigit(2, (n / 10) % 10) ;
		SEG7_setDigit(1, (n / 100) % 10) ;
		SEG7_setDigit(0, (n / 1000) % 10 );
	}
}


/* 7ZOgLEDւ1o͂̃ZOǧʎw */
void
SEG7_setSegment(char i, byte ptn)
{
	g7SEG[(i & 3)] = ptn ;
}


#if defined(PICSYS18_SP)
/***********************************************************
	LEDACւ̓o
***********************************************************/

void
LED_write(byte n)
{
	g7SEG[NDIGIT] = n ;
}

void
LED_bitSet(byte i)
{
	g7SEG[NDIGIT] |= BIT(i) ;
}

void
LED_bitClear(byte i)
{
	g7SEG[NDIGIT] &= ~BIT(i) ;
}


int
LED_read()
{
	return g7SEG[NDIGIT] ;
}

int
LED_bitGet(byte i)
{
	return (g7SEG[NDIGIT] & BIT(i)) ? 1 : 0 ;
}

#endif


/***********************************************************
	_Ci~bN\F荞݃T[rX[`̌Ăяo
***********************************************************/

#ifdef	OPTIMIZE

void
isr_SEG7_update()
{
	char i ;

	/* \錅̊mF */
    if (gDL >= NDIGIT_LED)
		gDL = 0 ;

	/* RׂĔANeBu */
	OPT_SEG1 = 1 ;
	OPT_SEG2 = 1 ;
	OPT_SEG3 = 1 ;
	OPT_SEG4 = 1 ;
#if defined(OPT_SEG5)
	OPT_SEG5 = 1 ;
#endif

#if defined(PIC_DEV_2550URL)
	isr_optShiftOut(LSBFIRST, 0xff) ;

	isr_SW_update() ;
#endif

	/* 1̕\f[^(ANeBuEj̏o */
	isr_optShiftOut(LSBFIRST, ~g7SEG[gDL]) ;

	/* ỸRANeBu */
	switch (gDL++) {
		case 0:
			OPT_SEG1 = 0 ;
			break ;
		case 1:
			OPT_SEG2 = 0 ;
			break ;
		case 2:
			OPT_SEG3 = 0 ;
			break ;
		case 3:
			OPT_SEG4 = 0 ;
			break ;
#if defined(OPT_SEG5)
		case 4:
			OPT_SEG5 = 0 ;
			break ;
#endif
	}
}

#else

void
isr_SEG7_update()
{
	char i ;
	
	/* \錅̊mF */
    if (gDL >= NDIGIT_LED)
		gDL = 0 ;

	/* RׂĔANeBu */
    for (i = 0; i < NDIGIT_LED; i++)
		isr_bitOut(segDigit[i], HIGH) ;

#if defined(PIC_DEV_2550URL)
	shiftOut(dataPin, clockPin, LSBFIRST, 0xff) ;

	isr_SW_update() ;
#endif

	/* 1̕\f[^(ANeBuEj̏o */
	shiftOut(dataPin, clockPin, LSBFIRST, ~g7SEG[gDL]) ;

	/* ỸRANeBu */
	isr_bitOut(segDigit[gDL++], LOW) ;
}

#endif

#endif
