/***********************************************************

	pic18seg7.c

	Version 0.92: 2009/09/21

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys18.h"


static byte _u1RxBuffer[RX_BUFFER_SIZE] ;
static int _u1RxHead = -1;
static int _u1RxTail ;


/***********************************************************
	VAC̏
***********************************************************/

#if defined(PIC_DEV_2420RL)

void
Serial_begin(long baud)
{
// lɐݒ
	TXSTA = 0x00 ;
	RCSTA = 0x00 ;
 
 // {[[gݒľvZƐݒ
#if F_CPU < 10MHz
		TXSTAbits.BRGH = 1 ;
		SPBRG = F_CPU / 16 / baud - 1 ;
#else
		SPBRG = F_CPU / 64 / baud - 1 ;
#endif

	RCSTAbits.CREN = 1 ;	// pM

	_u1RxHead = 0 ;
	_u1RxTail = 0 ;

// M@\̋N
	TRISCbits.TRISC7 = 1 ;
	TRISCbits.TRISC6 = 1 ;

	TXSTAbits.TXEN = 1 ;
	RCSTAbits.SPEN = 1 ;
}


/***********************************************************
	VAC̒~
***********************************************************/

void
Serial_end()
{
// lɕA
	TXSTA = 0x00 ;
	RCSTA = 0x00 ;

	_u1RxHead = -1 ;

// RCIE, TXIE: 荞݂̉
	PIE1 &= 0b11001111 ;
}


/***********************************************************
	̎M
***********************************************************/

int
Serial_getc()
{
#ifdef USE_SERIAL_INT
	byte c ;
	
	if (_u1RxHead == _u1RxTail)
		return -1 ;

	c = _u1RxBuffer[_u1RxTail] ;

	_u1RxTail = (_u1RxTail + 1) & (RX_BUFFER_SIZE - 1) ;

	return c ;
#else
	if (!PIR1bits.RCIF)
		return -1 ;

	return RCREG ;
#endif
}


int
Serial_available()
{
#ifdef USE_SERIAL_INT
	int i ;

	i = _u1RxHead - _u1RxTail ;

	if (i < 0)
		i += RX_BUFFER_SIZE ;

	return i ;
#else
	return PIR1bits.RCIF ;
#endif
}


/***********************************************************
	̑M
***********************************************************/

void
Serial_putc(char c)
{
	while (!TXSTAbits.TRMT)
		;

	TXREG = c ;
}


unsigned int
Serial_busy()
{
	return TXSTAbits.TRMT ;			///<@Mf[^̑oς݂̌
}


/***********************************************************
	(RAM)̏o
***********************************************************/

void
Serial_puts(char *s)
{
	while (*s) {
		while (Serial_busy())
			;
		Serial_putc(*s++) ;
	}
}


/***********************************************************
	(ROM)̏o
***********************************************************/

void
Serial_putrs(const char *s)
{
	while (*s) {
		while (Serial_busy())
			;
		Serial_putc(*s++) ;
	}
}


/***********************************************************
	荞݂ł̎Mobt@̃|[OFM荞݂Ɋ
***********************************************************/

void
_uxRxPolling()
{
#ifdef USE_SERIAL_INT
	if (_u1RxHead >= 0) {
		while (PIR1bits.RCIF) {
			if (((_u1RxHead + 1) & (RX_BUFFER_SIZE - 1)) == _u1RxTail) {
				// Overrun
//				_u1RxTail++ ;
//				_u1RxTail &= (RX_BUFFER_SIZE - 1) ;
			}
			_u1RxBuffer[_u1RxHead++] = RCREG ;
			_u1RxHead &= (RX_BUFFER_SIZE - 1) ;
		}
	}
#endif
}

#endif
