/***********************************************************

	picsys18.c

	Version 0.92: 2009/10/08

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys18.h"


/***********************************************************
	CONFIGݒ
***********************************************************/

#if defined(__18F2420) || defined(__18F2520)|| defined(__18F2620)

#ifdef XTAL_OSC
#if XTAL_OSC >= 32MHz
#pragma config OSC = HSPLL
#else
#pragma config OSC = HS
#endif

#else
#pragma config OSC = INTIO67
#endif

#pragma config MCLRE = OFF
#pragma config WDT = OFF
#pragma config PBADEN = ON
#pragma config LVP = OFF

#pragma config BOREN = OFF
#pragma config BORV = 2		// 1:4.3V,2:2.8V

#pragma config PWRT = ON
#pragma config FCMEN = ON

#elif defined(__18F4550) || defined(__18F2550) || defined(__18F2553)

#pragma config FOSC = HSPLL_HS
#pragma config PLLDIV = 2	// 2:8MHz, 5:20MHz

#if F_CPU == 48MHz
#pragma config CPUDIV = OSC1_PLL2
#elif F_CPU == 32MHz
#pragma config CPUDIV = OSC2_PLL3
#elif F_CPU == 24MHz
#pragma config CPUDIV = OSC3_PLL4
#elif F_CPU == 16MHz
#pragma config CPUDIV = OSC4_PLL6
#endif

#pragma config USBDIV = 2

#pragma config MCLRE = ON
#pragma config WDT = OFF
#pragma config PBADEN = ON
#pragma config LVP = OFF
#pragma config BOR = ON
#pragma config BORV = 2	// 1:4.33, 2:2.79, 3:2.05

#pragma config XINST = OFF


#elif defined(__18F26J50) || defined(__18F25J50) || defined(__18F24J50)

#pragma config XINST = OFF

#pragma config OSC = INTOSCPLL
#pragma config PLLDIV = 2	// 2:8MHz, 5:20MHz

#if F_CPU == 48MHz
#pragma config CPUDIV = OSC1
#elif F_CPU == 24MHz
#pragma config CPUDIV = OSC2_PLL2
#elif F_CPU == 16MHz
#pragma config CPUDIV = OSC3_PLL3
#elif F_CPU == 8MHz
#pragma config CPUDIV = OSC4_PLL6
#endif

#endif


/***********************************************************
	O[oϐ`
***********************************************************/

#if defined(__18F40PIN)
static rom byte _adMap[] = {RA(0), RA(1), RA(2), RA(3), RA(5), RE(0), RE(1), RE(2),
		RB(2), RB(3), RB(1), RB(4), RB(0)} ;
#elif defined(__18F28PIN)
static rom byte _adMap[] = {RA(0), RA(1), RA(2), RA(3), RA(5), NO_ASSIGN, NO_ASSIGN, NO_ASSIGN,
		RB(2), RB(3), RB(1), RB(4), RB(0)} ;
#elif defined(__18FJ28PIN)
#define	__NEW_AD
static rom byte _adMap[] = {RA(0), RA(1), RA(2), RA(3), RA(5), NO_ASSIGN, NO_ASSIGN, NO_ASSIGN,
		RB(2), RB(3), RB(1), RC(2), RB(0)} ;
#elif defined(__18F14K50)
static rom byte _adMap[] = {NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, RA(4), RC(0), RC(1), RC(2), RC(3),
		RC(6), RC(7), RB(4), RB(5)} ;
#elif defined(__18F1320)
static rom byte _adMap[] = {RA(0), RA(1), RA(2), RA(3), RB(0), RB(1), RB(4)} ;
#endif


byte _beepPin = NO_ASSIGN ;
byte _beepValue ;

byte _pwmPin[4] = {NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN} ;
byte _pwmValue[4] ;

byte _servoPin[4] = {NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN} ;
byte _servoDisable = 0x00 ;
int _servoValue[4] ;
int _servoMin[4] = {-100, -100, -100, -100} ;
int _servoMax[4] = {100, 100, 100, 100} ;


/***********************************************************
	VXȅ
***********************************************************/

static void
_initPicsys(void)
{ 
#if defined(__18F2420) || defined(__18F2520)|| defined(__18F2620)
#ifdef INT_OSC
	OSCCON = 0b01110000 ;
#if F_CPU == 32MHz
	OSCTUNEbits.PLLEN = 1 ;
#elif F_CPU == 8MHz
//	OSCTUNEbits.PLLEN = 0 ;
#else
#error M̎gw肪K؂ł͂܂
#endif
#endif
#endif
#if defined(__18F26J50) || defined(__18F25J50)|| defined(__18F24J50)
	OSCTUNEbits.PLLEN = 1 ;
#endif

	/* AiO͂fW^͂ */
//	ADCON1 = 0x0f ;

	/* IDLE[h𗘗p鏀 */
	OSCCONbits.IDLEN = 1 ;

	/* SW͂ɃvAbvt */
#if defined(__18F14K50)
	INTCON2bits.RABPU = 0 ;
#elif !(defined(__18F26J50) || defined(__18F25J50)|| defined(__18F24J50))
	INTCON2bits.RBPU = 0 ;
#endif

//	TIMER0_init() ;
	TIMER2_init() ;
}


/***********************************************************
	C֐
***********************************************************/

void
main(void)
{
	_initPicsys() ;
#if defined(PIC_DEV_2550URL)
	SW_init() ;
#endif

	setup() ;

	for (;;)
		loop() ;
}


/***********************************************************
	XCb`̏
***********************************************************/

#if defined(PIC_DEV_2550URL)
static byte __sw[6] ;

void
SW_init()
{
	pinMode(SW_ACTIVATE, OUTPUT) ;
	digitalWrite(SW_ACTIVATE, HIGH) ;

	__sw[0] = 0xff ;
	__sw[1] = 0xff ;
	__sw[2] = 0xff ;
	__sw[3] = 0xff ;
	__sw[4] = 0xff ;
	__sw[5] = 0xff ;
}


#if 1
void
isr_SW_update()
{
/*
	OPT_SEG1_TRIS = 1;
	OPT_SEG2_TRIS = 1;
	OPT_SEG3_TRIS = 1;
	OPT_SEG4_TRIS = 1;
	OPT_SR_DAT_TRIS = 1;
*/
	TRISB |= OPT_SW_MASK ;

	OPT_SW_ACTIVATE = 0 ;

	__sw[0] = OPT_SW1 ;
	__sw[1] = OPT_SW2 ;
	__sw[2] = OPT_SW3 ;
	__sw[3] = OPT_SW4 ;
	__sw[4] = OPT_SW5 ;
	__sw[5] = OPT_SW6 ;

	OPT_SW_ACTIVATE = 1 ;
/*
	OPT_SEG1_TRIS = 0;
	OPT_SEG2_TRIS = 0;
	OPT_SEG3_TRIS = 0;
	OPT_SEG4_TRIS = 0;
	OPT_SR_DAT_TRIS = 0;
*/
	TRISB &= ~OPT_SW_MASK ;
}
#else
extern byte dataPin, clockPin ;
#if defined(USE_SEG7)
extern byte segDigit[] ;
#elif defined(USE_DML)
extern byte ePin ;
extern byte dbPin[3] ;
#endif

void
isr_SW_update()
{
	char i ;

#if defined(USE_SEG7)
    for (i = 0; i < NSEG; i++)
		pinMode(segDigit[i], INPUT) ;
#elif defined(USE_DML)
    for (i = 0; i < NSEG-1; i++)
		pinMode(dbPin[i], INPUT) ;
	pinMode(ePin, INPUT) ;
#endif

	pinMode(dataPin, INPUT) ;

	isr_digitalWrite(SW_ACTIVATE, LOW) ;

	__sw[0] = digitalRead(SW1) ;
	__sw[1] = digitalRead(SW2) ;
	__sw[2] = digitalRead(SW3) ;
	__sw[3] = digitalRead(SW4) ;
	__sw[4] = digitalRead(SW5) ;
	__sw[5] = digitalRead(SW6) ;

	isr_digitalWrite(SW_ACTIVATE, HIGH) ;

#if defined(USE_SEG7)
    for (i = 0; i < NSEG; i++)
		pinMode(segDigit[i], OUTPUT) ;
#elif defined(USE_DML)
    for (i = 0; i < NSEG-1; i++)
		pinMode(dbPin[i], OUTPUT) ;
	pinMode(ePin, OUTPUT) ;
#endif
	pinMode(dataPin, OUTPUT) ;
}
#endif

byte
SW_read(byte n)
{
	return __sw[n] & 1 ;
}

#endif


/***********************************************************
	sI/O
***********************************************************/

void
pinMode(byte pin, byte mode)
{
	char i ;
	byte b, pcfg ;
	volatile near unsigned char *p ;

/* Ys̋@\ */
	/* AiO̖͂ */
#ifdef __NEW_AD
	for (i = 0; i < sizeof(_adMap)/sizeof(byte); i++)
		if (_adMap[i] == pin) {
			if (i > 7) {
				ANCON1 |= BIT(i - 8) ;
			} else {
				ANCON0 |= BIT(i) ;
			}	
			break ;
		}

#else
	for (i = 0; i < sizeof(_adMap)/sizeof(char); i++)
		if (_adMap[i] == pin) {
			pcfg = (~(i) & 0b1111) ;
			if ((ADCON1 & 0b1111) < pcfg) { // AiOsk
				ADCON1 = pcfg ;
			}
			break ;
		}
#endif

	/* r[v@\̉ */
	if (pin == _beepPin) {
		_beepPin = NO_ASSIGN ;
		digitalWrite(pin, LOW) ; // dȂ悤
	}

	/* PWM@\̉ */
	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin)
			_pwmPin[i] = NO_ASSIGN ;

	/* T[{@\̉ */
	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin) {
			noInterrupts() ;
			_servoDisable |= BIT(i) ;
			interrupts() ;
		}

/* Ys̋@\̍ĐݒJn */
	if (mode >= 2) {
		/* ݒ肾G̓Iȏ͊荞݃T[rX[` */
		if (mode == OUT_BEEP) {
			_beepPin = pin ;
			_beepValue = 0 ;
			digitalWrite(pin, LOW) ;
		} else if (isPWM(mode)) {
			_pwmPin[mode & 0b11] = pin ;
			_pwmValue[mode & 0b11] = 0 ;
		} else if (isSERVO(mode)) {
			_servoPin[mode & 0b11] = pin ;
			_servoValue[mode & 0b11] = 0 ;
/*
			_servoMin[mode & 0b11] = -100 ;
			_servoMax[mode & 0b11] = 100 ;
*/
		}

		mode = OUTPUT ;
	}

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00000111) ;
	/* ws̓o̓[hݒ */
	p = &TRISA + GET_PORT(pin) - 2 ;

	if (mode == OUTPUT) {
		(*p) &= ~b ;
	} else {
		(*p) |= b ;
	}
}


void
__pinMode(byte pin, byte mode)
{
	byte b ;
	volatile near unsigned char *p ;

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00000111) ;
	/* ws̓o̓[hݒ */
	p = &TRISA + GET_PORT(pin) - 2 ;

	if (mode == OUTPUT) {
		(*p) &= ~b ;
	} else {
		(*p) |= b ;
	}
}


void
digitalWrite(byte pin, int value)
{
	char i ;
	byte b ;
	volatile near unsigned char *p ;

	/* r[v蓖ăs */
	if (pin == _beepPin) {
		if (value > 8)
			_beepValue = 8 ;
		else if (value < 0)
			_beepValue = 0 ;
		else
			_beepValue = value ;

		return ;
	}

	/* PWM蓖ăs */
	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin) {
			if (value < 0)
				value = 0 ;
#if HEART_BEAT == 2000Hz
			if (value >= 100)
				_pwmValue[i] = 32 ;
			else
				_pwmValue[i] = value * 32 / 100 ;
#else
			if (value >= 100)
				_pwmValue[i] = 16 ;
			else
				_pwmValue[i] = value * 16 / 100;
#endif
			return ;
		}

	/* T[{蓖ăs */
	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin) {
			if (value > _servoMax[i])
				_servoValue[i] = _servoMax[i] ;
			else if (value < _servoMin[i])
				_servoValue[i] = _servoMin[i] ;
			else
				_servoValue[i] = value ;

			return ;
		}

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00000111) ;

	/* wsɒlo */
	p = &LATA + GET_PORT(pin) - 2 ;
	if (value == 0) {
		(*p) &= ~b ;
	} else {
		(*p) |= b ;
	}
}


void
bitOut(byte pin, int value)
{
	byte b ;
	volatile near unsigned char *p ;

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00000111) ;

	/* wsɒlo */
	p = &LATA + GET_PORT(pin) - 2 ;
	if (value == 0) {
		(*p) &= ~b ;
	} else {
		(*p) |= b ;
	}

}


void
isr_bitOut(byte pin, int value)
{
	byte b ;
	volatile near unsigned char *p ;

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00000111) ;

	/* wsɒlo */
	p = &LATA + GET_PORT(pin) - 2 ;
	if (value == 0) {
		(*p) &= ~b ;
	} else {
		(*p) |= b ;
	}
}


int
digitalRead(byte pin)
{
	char i ;
	byte b ;
	volatile near unsigned char *p ;

	if (pin == _beepPin)
		return _beepValue ;

	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin) {
#if HEART_BEAT == 2000Hz
			if (_pwmValue[i] == 32)
				return 100 ;
			return _pwmValue[i] * 100 / 32 ;
#else
			if (_pwmValue[i] == 16)
				return 100 ;
			return _pwmValue[i] * 100 / 16 ;
#endif
		}

	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin)
			return _servoValue[i] ;

	/* ws|[g̓ǂݏo */
	switch (pin >> 3) {
#if defined(PIC_DEV_2550URL)
		/* zXCb` */
		case ID_VSW: // PORTE
			return __sw[(pin & 0b00000111)] ? 1 : 0 ;
			break ;		
#endif
		default:
			p = &PORTA + GET_PORT(pin) - 2 ;
			b = *p ;
			break ;
	}

	/* ws̓͒l擾 */
	return 1 & (b >> (pin & 0b00000111)) ;
}


/***********************************************************
	AiOsI/O
***********************************************************/

/* b菈F傫ς\ */
void
analogWrite(byte pin, int value)
{
	char i ;

	if (pin == _beepPin) {
		if (value > 8)
			_beepValue = 8 ;
		else if (value < 0)
			_beepValue = 0 ;
		else
			_beepValue = value ;

		return ;
	}

	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin) {
#if HEART_BEAT == 2000Hz
			_pwmValue[i] = (value >> 3) & 0b11111 ;
#else
			_pwmValue[i] = (value >> 4) & 0b1111 ;
#endif
			return ;
		}

	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin) {
			if (value > _servoMax[i])
				_servoValue[i] = _servoMax[i] ;
			else if (value < _servoMin[i])
				_servoValue[i] = _servoMin[i] ;
			else
				_servoValue[i] = value ;

			return ;
		}
}


static byte _vref = 0 ;

int
analogRead(byte pin)
{
	int v ;
	byte pcfg ;

	/* AiOs */
	if (!isAN(pin))
		return 0 ;

	/* LȃAiOsH */
	if (_adMap[pin] == NO_ASSIGN)
		return 0 ;

	/* AiOsnCCs[_X */
	pinMode(_adMap[pin], INPUT) ;

	// CHS, ADON
	ADCON0 = 0b00000001 | (pin << 2) ;

	/* ỸAiOsL */
#ifdef __NEW_AD
	if (pin > 7) {
		ANCON1 &= ~BIT(pin - 8) ;
	} else {
		ANCON0 &= ~BIT(pin) ;
	}	

	ADCON0bits.VCFG0 = _vref ? 1 : 0 ;

//	ADCON1bits.ADFM = 1 ;
	ADCON1 = 0b10110110 ;
#else
	pcfg = (~(pin + 1) & 0b1111) ;
	if ((ADCON1 & 0b1111) > pcfg) { // AiOsg
		ADCON1 = pcfg | _vref ;
	} else { // łɊgĂ钆̃s
		ADCON1bits.VCFG0 = _vref ? 1 : 0 ;
	}
	// ADFM, ACQT, ADCS
//	ADCON2bits.ADFM = 1 ;
	ADCON2 = 0b10110110 ;
#endif

	ADCON0bits.GO = 1 ;

	while (ADCON0bits.NOT_DONE)
		;

	/* v[VȂ̂ŃVtgOɃLXgKvFIvVŕύXł */
	v = (((int)ADRESH) << 8) + ADRESL ;

	ADCON0 = 0 ;

	return v ;
}


void
analogReference(byte type)
{
#if !defined(__18F14K50)
	pinMode(_adMap[AN(3)], INPUT) ;
#else
	pinMode(_adMap[AN(4)], INPUT) ;
#endif

	if (type == DEFAULT)
		_vref = 0 ;
	else if (type == EXTERNAL)
		_vref = 0b00010000 ;
}


/***********************************************************
	VAf[^o͏
***********************************************************/

#ifdef	OPTIMIZE

void
isr_optShiftOut(byte order, byte value)
{
	byte b, i, v ;

	for (i = 0; i < 8; i++)  {
		v = value & ((order == LSBFIRST) ? 1 : 0b10000000) ;

		OPT_SR_DAT = v ? 1 : 0 ;
		OPT_SR_CLK = 1 ;
		OPT_SR_CLK = 0 ;

		if (order == LSBFIRST)
			value >>= 1 ;
		else
			value <<= 1 ;
	}
}

#endif


void
shiftOut(byte data, byte clock, byte order, byte value)
{
	byte db, cb, i, v ;
	volatile near unsigned char *dp, *cp ;

	dp = &LATA + GET_PORT(data) - 2 ;
	db = BIT(data & 0b00000111) ;
	cp = &LATA + GET_PORT(clock) - 2 ;
	cb = BIT(clock & 0b00000111) ;

	for (i = 0; i < 8; i++)  {
		v = value & ((order == LSBFIRST) ? 1 : 0b10000000) ;

		/* f[^s */
		if (v == 0) {
			(*dp) &= ~db ;
		} else {
			(*dp) |= db ;
		}

		/* NbNs */
		(*cp) |= cb ;
		(*cp) &= ~cb ;

		if (order == LSBFIRST)
			value >>= 1 ;
		else
			value <<= 1 ;
	}
}


/***********************************************************
	l->ϊ֐
***********************************************************/

int
ltos(char buf[], long n, byte base)
{
	char rbuf[12] ;
	char i, j ;
	byte minus = FALSE ;

	/* 0͓ */
	if (n == 0) {
		buf[0] = '0';
		buf[1] = '\0';

		return 1;
	}

	/* 10ȉꍇ̂ݕ̒l̏ */
	if ((base == 10) && (n < 0)) {
		minus = TRUE ;
		n = -n ;
	}

	/* W16rbgɐ؂藎Ƃ */
	if (base < 8)
		n &= 0xffff ;

	for (i = 0; n > 0; i++) {
		j = n % base;
		if (j > 9) {
			rbuf[i] = j + ('A' - 10) ;
		} else {
			rbuf[i] = j + '0' ;
		}
		n /= base;
	}

	j = 0 ;
	if (minus)
		buf[j++] = '-' ;

	while (i > 0)
		buf[j++] = rbuf[--i] ;

	buf[j] = '\0' ;

	return j ;
}
